/* Copyright (C) 2002 Edson Pereira, PU1JTE, N1VTN, 7N4NCL
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * version 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, download a copy
 * from http://www.fsf.org
 *
 *
 * Propagator algorithm derived from John A. Magliacane,
 * KD2BD's Predict.
 *
 */

#ifndef MOONPROPAGATOR_H
#define MOONPROPAGATOR_H

#include <math.h>

class MoonPropagator
{
public:
   MoonPropagator( double, double );
   ~MoonPropagator();
   
   void propagate( double daynum );
   double getAz();
   double getEl();
   double getLat();
   double getLon();
   
private:
   double t1, t2, t3, ew, en, e, n, si, co, ra, gh,
          lh, gm, de, se, gs, dc, el, az, mm, yr, ro, mr;
   double stnlat, stnlon;
   double daynum;
   static const double C1 = 0.91746406;
   static const double S1 = 0.397818675;
   static const double TP = 6.283185307179586;
   static const double deg2rad = 1.74532925199e-02;
   double riseTime, setTime;
   
   double fixAngle( double x );
                            
};

#endif
